using System;
using System.Threading;
using Microsoft.Practices.EnterpriseLibrary.Security;
using BookingApp.TaskForms;

namespace BookingApp.Helpers
{
    public class ProfileHelper
    {
        private static ProfileInfo _profile;

        private ProfileHelper() {}

        public static void ClearProfile()
        {
            _profile = null;
        }

        public static void LoadProfile(BaseForm taskForm)
        {
            // TODO: Load & Apply Profile
 
            // Lookup profile information
            if (_profile == null)
            {
                IProfileProvider profileProvider;
                profileProvider = ProfileFactory.GetProfileProvider();
 
                _profile = (ProfileInfo) profileProvider.GetProfile(
                    Thread.CurrentPrincipal.Identity
                    );
            }
 
            // Apply profile
            if (_profile == null) _profile = new ProfileInfo();
            taskForm.FormColor = _profile.FormColor;
            taskForm.TextColor = _profile.TextColor;
        }

        public static void SaveProfile(BaseForm taskForm)
        {
            // TODO: Save Profile
 
            // Collect profile information
            if (_profile == null) _profile = new ProfileInfo();
            _profile.FormColor = taskForm.FormColor;
            _profile.TextColor = taskForm.TextColor;
 
            // Save Profile Information
            IProfileProvider profileProvider;
            profileProvider = ProfileFactory.GetProfileProvider();
 
            profileProvider.SetProfile(Thread.CurrentPrincipal.Identity, _profile);
        }    
	}
}
