using System;
using System.Drawing;
using System.Runtime.Serialization;

namespace BookingApp.Helpers
{
    [Serializable()]        
    public class ProfileInfo
    {
        private Color m_formColor;
        private Color m_textColor;
        
        public ProfileInfo() : 
            this (SystemColors.InactiveCaption, SystemColors.HighlightText)
        {
        }
        
        public ProfileInfo(Color formColor, Color textColor)
        {
            this.m_formColor = formColor;
            this.m_textColor = textColor;
        }

        public Color FormColor
        {
            get { return this.m_formColor; }
            set { this.m_formColor = value; }
        }
        
        public Color TextColor
        {
            get { return this.m_textColor; }
            set { this.m_textColor = value; }
        }
    }
}
