using System;
using System.Security;
using System.Security.Principal;
using System.Threading;
using Microsoft.Practices.EnterpriseLibrary.Security;

namespace BookingApp.Helpers
{
	public class SecurityHelper
	{
        private SecurityHelper() {}
		public static NamePasswordCredential UserCredential;
	
        public static bool Authenticate(string username, string password)
        {
            bool authenticated = false;

            // TODO: Authenticate Credentials

            NamePasswordCredential credentials;
            credentials = new NamePasswordCredential(username, password); 

			 UserCredential = credentials;

            IAuthenticationProvider authprovider;
            authprovider = AuthenticationFactory.GetAuthenticationProvider();

            IIdentity identity;
            authenticated = authprovider.Authenticate(credentials, out identity);

            if (!authenticated)
            {
                throw new VerificationException("Invalid username or password.");
            }

            // TODO: Get Roles

            IRolesProvider rolesprovider;
            rolesprovider = RolesFactory.GetRolesProvider();

            IPrincipal principal;
            principal = rolesprovider.GetRoles(identity);

            // Place user's principal on the thread
            Thread.CurrentPrincipal = principal;
			            
            return authenticated;
        }

        public static bool Authorized(string rule)
        {
            bool authorized = false;

            // TODO: Task Authorize
            
            IAuthorizationProvider ruleProvider;
            ruleProvider = AuthorizationFactory.GetAuthorizationProvider();
            
            authorized = ruleProvider.Authorize(Thread.CurrentPrincipal, rule);

            return authorized;
        }
    }
}
