using System;
using System.Drawing;
using System.Windows.Forms;
using BookingApp.Helpers;

namespace BookingApp.TaskForms
{
	/// <summary>
	/// Summary description for BaseForm.
	/// </summary>
	public class BaseForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem mnuOption;
        private System.Windows.Forms.ColorDialog colorDialog1;
        private System.Windows.Forms.MenuItem mnuOptionFormColor;
        private System.Windows.Forms.MenuItem mnuOptionTextColor;
		private System.Windows.Forms.Button btnDone;
		private System.Windows.Forms.Label lblMsg;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BaseForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BaseForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.btnDone = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuOption = new System.Windows.Forms.MenuItem();
			this.mnuOptionFormColor = new System.Windows.Forms.MenuItem();
			this.mnuOptionTextColor = new System.Windows.Forms.MenuItem();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.lblMsg = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(592, 48);
			this.panel1.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.SystemColors.HighlightText;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(576, 32);
			this.label1.TabIndex = 0;
			this.label1.Text = "Form Task ...";
			// 
			// btnDone
			// 
			this.btnDone.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDone.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnDone.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnDone.Location = new System.Drawing.Point(488, 330);
			this.btnDone.Name = "btnDone";
			this.btnDone.Size = new System.Drawing.Size(88, 32);
			this.btnDone.TabIndex = 1;
			this.btnDone.Text = "Done";
			this.btnDone.Click += new System.EventHandler(this.btnDone_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuOption});
			// 
			// mnuOption
			// 
			this.mnuOption.Index = 0;
			this.mnuOption.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuOptionFormColor,
																					  this.mnuOptionTextColor});
			this.mnuOption.Text = "&Options";
			// 
			// mnuOptionFormColor
			// 
			this.mnuOptionFormColor.Index = 0;
			this.mnuOptionFormColor.Text = "&Form Color";
			this.mnuOptionFormColor.Click += new System.EventHandler(this.mnuOptionFormColor_Click);
			// 
			// mnuOptionTextColor
			// 
			this.mnuOptionTextColor.Index = 1;
			this.mnuOptionTextColor.Text = "&Text Color";
			this.mnuOptionTextColor.Click += new System.EventHandler(this.mnuOptionTextColor_Click);
			// 
			// lblMsg
			// 
			this.lblMsg.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMsg.ForeColor = System.Drawing.SystemColors.Highlight;
			this.lblMsg.Location = new System.Drawing.Point(16, 336);
			this.lblMsg.Name = "lblMsg";
			this.lblMsg.Size = new System.Drawing.Size(440, 24);
			this.lblMsg.TabIndex = 2;
			this.lblMsg.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// BaseForm
			// 
			this.AcceptButton = this.btnDone;
			this.AutoScaleBaseSize = new System.Drawing.Size(7, 17);
			this.CancelButton = this.btnDone;
			this.ClientSize = new System.Drawing.Size(592, 376);
			this.Controls.Add(this.lblMsg);
			this.Controls.Add(this.btnDone);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "BaseForm";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.BaseForm_Load);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

        private void btnDone_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void mnuOptionFormColor_Click(object sender, System.EventArgs e)
        {
            this.colorDialog1.Color = this.FormColor;

            DialogResult dr = this.colorDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                this.FormColor = this.colorDialog1.Color;

                ProfileHelper.SaveProfile(this);
            }
        }

        private void mnuOptionTextColor_Click(object sender, System.EventArgs e)
        {
            this.colorDialog1.Color = this.TextColor;

            DialogResult dr = this.colorDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                this.TextColor = this.colorDialog1.Color;

                ProfileHelper.SaveProfile(this);
            }
        }

        private void BaseForm_Load(object sender, System.EventArgs e)
        {
            ProfileHelper.LoadProfile(this);
        }

        public string FormTask
        {
            get { return this.label1.Text; }
            set { this.label1.Text = value; }
        }
    
		public string Message
		{
			get { return this.lblMsg.Text; }
			set { this.lblMsg.Text = value; }
		}
		
		public Color FormColor
        {
            get { return this.panel1.BackColor; }
            set { this.panel1.BackColor = value; }
        }
    
        public Color TextColor
        {
            get { return this.label1.ForeColor; }
            set { this.label1.ForeColor = value; }
        }
    }
}
